
<template>
    <el-container style="height: 100%">
        <el-header color="#333">
            <commonheader></commonheader>
        </el-header>
        <el-container>
            <el-aside width="auto">
                <commonaside></commonaside>
            </el-aside>
            <el-main>
              <div class="tabControl">
                  <el-table :data="foodOrderList" style="width: 100%">
                    <el-table-column type="expand">
                      <template slot-scope="props">
                        <el-card class="el-card">
                          <el-row :gutter="200" class="el-row"  type="flex"  v-for="item in props.row.foodList" id=item :key="item.foodId">
                              <el-col :lg="6" :xs="2" style="height: 10px">
                                <img :src="item.foodImage" class="image" style="height: 200px;">
                              </el-col>
                              <el-col :lg="12" :xs="2" >
                                <el-form label-position="left" inline class="demo-table-expand">
                                  <el-form-item label="食品ID">
                                    <span>{{ item.foodId }}</span>
                                  </el-form-item>
                                  <el-form-item label="店铺ID">
                                    <span>{{ item.foodShopId }}</span>
                                  </el-form-item>
                                  <el-form-item label="食品名称">
                                    <span>{{ item.foodName }}</span>
                                  </el-form-item>

                                  <el-form-item label="价格">
                                    <span>{{ item.foodPrice }}</span>
                                  </el-form-item>
                                  <el-form-item label="卡路里">
                                    <span>{{ item.foodCalorie }}</span>
                                  </el-form-item>
                                  <el-form-item label="原料">
                                    <span>{{ item.foodIngredient }}</span>
                                  </el-form-item>

                                  <el-form-item label="食物数量:">
                                    <span >{{ item.foodNumber }}</span>
                                  </el-form-item>
                                  <el-form-item label="类别:">
                                    <span >{{ item.foodCategory }}</span>
                                  </el-form-item>
                                  <el-form-item label="食品介绍:">
                                    <span >{{ item.foodIntroduction }}</span>
                                  </el-form-item>
                                  <el-form-item label="">
                                    <span></span>
                                  </el-form-item>
                                </el-form>
                              </el-col>
                          </el-row>
                            <el-row :gutter="200" class="el-row"  type="flex">
                              <el-col :lg="20" :xs="2" >
                                <el-form label-position="left" inline class="demo-table-expand">
                                  <el-form-item label="评论:">
                                    <span ><br>{{ props.row.foodOrderComment }}</span>
                                  </el-form-item>
                                  <el-form-item label="">
                                    <span></span>
                                  </el-form-item>
                                </el-form>
                              </el-col>
                            </el-row>
                          </el-card>
                      </template>
                    </el-table-column>
                    <el-table-column
                      label="订单号"
                      prop="foodOrderId">
                    </el-table-column>
                    <el-table-column
                      label="订单商家"
                      prop="ShopName">
                    </el-table-column>
                    <el-table-column
                      label="总价值"
                      prop="foodOrderPrice">
                    </el-table-column>
                    <el-table-column
                      label="总热量"
                      prop="foodOrderCalorie">
                    </el-table-column>
                    <el-table-column
                      label="配送地址"
                      prop="foodOrderLocation">
                    </el-table-column>
                    <el-table-column
                      label="配送方式"
                      :filters="[{text: '未选择', value: 0}, { text: '自取', value: 1 }, {text: '外送', value: 2}]"
                      :filter-method="filterMethodTag"
                      filter-placement="bottom-end">
                      <template slot-scope="scope">
                        <el-tag
                          :type="scope.row.foodOrderRiderSend ? 'success':'info'"
                          disable-transitions v-if="scope.row.foodOrderStatus !== 0">{{scope.row.foodOrderRiderSend ? '外送' : '自取'}}</el-tag>
                        <el-select v-model="scope.row.foodOrderRiderSend" placeholder="请选择" v-if="scope.row.foodOrderStatus === 0">
                          <el-option
                            v-for="item in options"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value">
                          </el-option>
                        </el-select>
                      </template>
                    </el-table-column>
                  <el-table-column
                    label="订单状态"
                    :filters="[{text: '等待用户确认', value: 0 },{ text: '等待商户接单', value: 1 }, {text: '商户处理中', value: 2}, {text: '待骑手接单', value: 6} ,{text: '待用户评价', value: 3}, {text: '订单已完成', value: 4}]"
                    :filter-method="filterStatusTag"
                    filter-placement="bottom-end">
                    <template slot-scope="scope">
                      <el-tag
                        :type="StatusType[scope.row.foodOrderStatus]"
                        disable-transitions>{{StatusName[scope.row.foodOrderStatus]}}</el-tag>
                    </template>
                  </el-table-column>
                  <el-table-column label="操作">
                    <template slot-scope="scope">
                      <el-button type="text" @click="USetRidder(scope.row.index)" size="small" v-if="scope.row.foodOrderStatus === 0" :disabled = "disabled">确认</el-button>
                      <el-button type="text" @click="UComment(scope.row.index)" size="small" v-if="scope.row.foodOrderStatus === 3" :disabled = "disabled">发表评论</el-button>
                    </template>
                  </el-table-column>
                </el-table>
                <div style="width: 100%; text-align:center; margin-top: 20px;" v-if="islogin">
                  <el-button type="success" @click="openFoddRecommand()"><i class="el-icon-plus"></i>餐品推荐</el-button>
                </div>
                <el-dialog title="订单推荐" :visible.sync="dialogTableVisible">
                  <el-table :data="RecFoodList" style="width: 100%">
                    <el-table-column type="expand">
                      <template slot-scope="props">
                        <el-card class="el-card">
                          <el-row :gutter="100" class="el-row"  type="flex">
                            <el-col :lg="8" :xs="24">
                              <img :src="props.row.foodImage" class="image">
                            </el-col>
                            <el-col :lg="14" :xs="24" >
                              <el-form label-position="left" inline class="demo-table-expand">
                                <el-form-item label="食品ID">
                                  <span>{{ props.row.foodId }}</span>
                                </el-form-item>
                                <el-form-item label="店铺ID">
                                  <span>{{ props.row.foodShopId }}</span>
                                </el-form-item>
                                <el-form-item label="食品名称">
                                  <span>{{ props.row.foodName }}</span>
                                </el-form-item>
                                <el-form-item label="价格">
                                  <span>{{ props.row.foodPrice }}</span>
                                </el-form-item>
                                <el-form-item label="卡路里">
                                  <span>{{ props.row.foodCalorie }}</span>
                                </el-form-item>
                                <el-form-item label="原料">
                                  <span>{{ props.row.foodIngredient }}</span>
                                </el-form-item>
                                <el-form-item label="食物数量:">
                                  <span >{{ props.row.foodNumber }}</span>
                                </el-form-item>
                                <el-form-item label="类别:">
                                  <span >{{ props.row.foodCategory }}</span>
                                </el-form-item>
                                <el-form-item label="食品介绍:">
                                  <span >{{ props.row.foodIntroduction }}</span>
                                </el-form-item>
                                <el-form-item label="购买数量">
                                  <span>{{ props.row.foodCnt }}</span>
                                </el-form-item>
                              </el-form>
                            </el-col>
                          </el-row>
                        </el-card>
                      </template>
                    </el-table-column>
                    <el-table-column
                      label="食物名称"
                      prop="foodName">
                    </el-table-column>
                    <el-table-column
                      label="食物类型"
                      prop="foodCategory">
                    </el-table-column>
                    <el-table-column
                      label="购买数量"
                      prop="foodCnt">
                    </el-table-column>
                    <el-table-column
                      label="食物热量"
                      prop="foodCalorie">
                    </el-table-column>
                    <el-table-column
                      label="食物价格"
                      prop="foodPrice">
                    </el-table-column>
                  </el-table>
                  <span style="width: 100%; text-align: right; font-size: 1.2em;">{{'总热量:' + totalCalorie}}</span>
                  <span style="width: 100%; text-align: right; font-size: 1.5em; color: red;">{{'￥ ' + totalPrice}}</span>
                  <div style="width: 100%; text-align:center;">
                    <el-button type="success" @click="FoodRecommand()" :disabled = "recdisable">{{RecBtnStr}}</el-button>
                    <el-button type="success" @click="gotoRecShop()">修改订单</el-button>
                    <el-button type="success" @click="settlement()">确认订单</el-button>
                  </div>
                </el-dialog>
              </div>
            </el-main>
        </el-container>
    </el-container>
</template>

<script>
import OrderManage from '@/services/UserFoodOrderManager'
import commonaside from '../components/commonaside.vue'
import BrowseFoodByShopID from '@/services/BrowseFoodByShopID'
import commonheader from '../components/commonheader.vue'
import showViewInfoService from '@/services/showViewInfoService'
export default {
  components: {
    commonaside,
    commonheader
  },

  name: 'AdminRecognize',
  data () {
    return {
      activeName: 'rider',
      StatusType: [
        'info',
        'warning',
        'warning',
        'primary',
        'success',
        'error',
        'warning'
      ],
      StatusName: [
        '等待用户确认',
        '等待商户接单',
        '商户处理中',
        '待用户评价',
        '订单已完成',
        '状态未定义',
        '待骑手接单'
      ],
      foodStatusName: [
        '未认证',
        '认证待审核',
        '修改待审核',
        '认证不通过',
        '修改不通过',
        '审核通过'
      ],
      options: [{
        value: false,
        label: '自取'
      }, {
        value: true,
        label: '配送'
      }],
      foodOrderList: [],
      user: {
      },
      shopInfo: {
      },
      isAdmin: false,
      isFoodMerchant: false,
      comment: '',
      hasFalse: false,
      disabled: false,
      dialogTableVisible: false,
      recdisable: false,
      timer: null,
      recommand: {
      },
      RecFoodList: [],
      RecFoodCnt: [],
      RecBtnStr: '重新推荐',
      cnt: 0,
      totalCalorie: 0,
      totalPrice: 0,
      islogin: false
    }
  },
  created () {
    this.islogin = this.$store.state.token !== ''
    if (this.$store.state.token !== '') {
      this.getOrderList()
    } else {
      this.$message({
        type: 'info',
        message: '您并无订单,无法查看'
      })
    }
  },
  methods: {
    async getOrderList () {
      try {
        var response = await showViewInfoService.getInfo({
          headers: {'Authorization': this.$store.state.token}
        })
        this.user = response.data.data.user
        this.isAdmin = false
        for (var j in this.user.roles) {
          if (this.user.roles[j] === 'admin') {
            this.isAdmin = true
          }
        }
        console.log('user')
        const responsef = await OrderManage.getOrders(this.user.userId, {
          headers: {'Authorization': this.$store.state.token}
        })
        this.foodOrderList = responsef.data.data.foodOrderList
        console.log(this.$store.state.token)
        var i
        for (i = 0; i < this.foodOrderList.length; i++) {
          var responseShop = await BrowseFoodByShopID.getShopGoodList(this.foodOrderList[i].foodOrderShopId, {
            headers: {'Authorization': this.$store.state.token}
          })
          this.foodOrderList[i].ShopName = responseShop.data.data.shopFood.shopName
          this.foodOrderList[i].index = i
        }
        this.$forceUpdate()
      } catch (error) {
        this.$message({
          showClose: true,
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,无法访问' : error.response.data.msg,
          type: 'error'
        })
      }
    },
    USetRidder (index) {
      if (this.foodOrderList[index].foodOrderRiderSend === undefined || this.foodOrderList[index].foodOrderRiderSend === false) {
        this.UserOp(0, index, -1)
        return
      }
      this.$prompt('请输入您选择的配送员ID', '提示', {
        confirmButtonText: '确定是他',
        cancelButtonText: '自动分配',
        inputPattern: /^[0-9]*[1-9][0-9]*$/,
        inputErrorMessage: 'ID格式错误'
      }).then(({ value }) => {
        console.log('then')
        this.UserOp(0, index, value)
      }).catch(() => {
        console.log('catch')
        this.UserOp(0, index, -1)
      })
    },
    UComment (index) {
      if (this.foodOrderList[index].foodOrderStatus < 3) {
        this.$message({
          showClose: true,
          message: '订单状态未完成，无法评论',
          type: 'error'
        })
        this.disabled = false
        return
      }

      this.$prompt('请输入您的评论', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消'
      }).then(({ value }) => {
        this.comment = value
        this.UserOp(2, index)
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消评论'
        })
      })
    },
    async UserOp (type, index, player) {
      console.log('token')
      console.log(this.$store.state.token)
      console.log('index')
      console.log(index)
      console.log(this.foodOrderList[index].foodOrderRiderSend)
      this.disabled = true
      try {
        var step = ''
        let response
        if (type === 0) {
          step = '订单选择配送方式'
          if (this.foodOrderList[index].foodOrderRiderSend === undefined || this.foodOrderList[index].foodOrderRiderSend === '') {
            this.$message({
              showClose: true,
              message: '订单未选择配送方式,请首先选择配送方式',
              type: 'error'
            })
            this.disabled = false
            return
          }
          console.log(this.foodOrderList[index].foodOrderId + '/' + this.foodOrderList[index].foodOrderRiderSend ? 1 : 0)
          response = await OrderManage.MerchantSendWay({
            foodOrderId: this.foodOrderList[index].foodOrderId,
            deliveryMethod: this.foodOrderList[index].foodOrderRiderSend ? 1 : 0
          }, this.foodOrderList[index].foodOrderId, this.foodOrderList[index].foodOrderRiderSend ? 1 : 0, {
            headers: {'Authorization': this.$store.state.token}
          })
          if (this.foodOrderList[index].foodOrderRiderSend) {
            step = '分配订单配送员'
            if (this.foodOrderList[index].foodOrderStatus > 0) {
              this.$message({
                showClose: true,
                message: '订单配送员已经指定,无法重复指定',
                type: 'error'
              })
              this.disabled = false
              return
            }
            response = await OrderManage.MerchantRider({
              foodOrderId: this.foodOrderList[index].foodOrderId,
              riderUserId: player
            }, this.foodOrderList[index].foodOrderId, player, {
              headers: {'Authorization': this.$store.state.token}
            })
          }
          step = '用户确认订单'
          response = await OrderManage.Confirm({
            foodOrderId: this.foodOrderList[index].foodOrderId,
            nextStatus: this.foodOrderList[index].foodOrderStatus + 1
          }, this.foodOrderList[index].foodOrderId, this.foodOrderList[index].foodOrderStatus + 1, {
            headers: {'Authorization': this.$store.state.token}
          })
        } else if (type === 1) {
          step = '商店确认订单'
          response = await OrderManage.Confirm({
            foodOrderId: this.foodOrderList[index].foodOrderId,
            nextStatus: this.foodOrderList[index].foodOrderStatus + 1
          }, this.foodOrderList[index].foodOrderId, this.foodOrderList[index].foodOrderStatus + 1, {
            headers: {'Authorization': this.$store.state.token}
          })
        } else if (type === 2) {
          step = '用户评价订单'
          response = await OrderManage.UserComment({
            userId: this.foodOrderList[index].foodOrderUserId,
            comment: this.comment
          }, this.foodOrderList[index].foodOrderId, {
            headers: {'Authorization': this.$store.state.token}
          })
        }
        console.log(response.data.code, response.data.msg)
        if (response.data === undefined || response.data.code !== 200) {
          this.hasFalse = true
          this.$message({
            showClose: true,
            message: step + (response.data === undefined ? '网络错误,无法访问' : response.data.msg),
            type: 'error'
          })
        } else {
          this.$message({
            showClose: true,
            message: step + response.data.msg,
            type: 'success'
          })
        }
      } catch (error) {
        this.disabled = false
        this.$message({
          showClose: true,
          message: step + (error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,无法访问' : error.response.data.msg),
          type: 'error'
        })
      }
      this.disabled = false
      this.getOrderList()
      this.$forceUpdate()
    },
    filterMethodTag (value, row) {
      if (value === 0) {
        return row.foodOrderStatus === 0
      } else if (value === 1) {
        return row.foodOrderRiderSend === false
      } else {
        return row.foodOrderRiderSend === true
      }
    },
    filterStatusTag (value, row) {
      console.log('val:' + value)
      return row.foodOrderStatus === value
    },
    openFoddRecommand () {
      this.FoodRecommand()
      this.dialogTableVisible = true
    },
    async FoodRecommand () {
      this.recdisable = true
      try {
        const response = await OrderManage.getRecommand({
          headers: {'Authorization': this.$store.state.token}
        })
        if (response.data.code !== 200) {
          this.$message({
            showClose: true,
            message: response.data.msg,
            type: response.data.code === 400 ? 'warning' : 'error'
          })
          this.recdisable = false
          return
        }
        this.recommand = response.data.data
        this.RecFoodList = response.data.data.foods
        this.RecFoodCnt = response.data.data.foodsCount
        var totalPrice = 0
        for (var i = 0; i < this.RecFoodList.length; i++) {
          this.RecFoodList[i].foodCnt = this.RecFoodCnt[i]
          totalPrice = totalPrice + this.RecFoodList[i].foodPrice * this.RecFoodCnt[i]
        }
        this.totalPrice = totalPrice.toFixed(1)
        this.totalCalorie = this.recommand.totalCalorie.toFixed(1)
        const TIME_COUNT = 5
        if (!this.timer) {
          this.cnt = TIME_COUNT
          this.timer = setInterval(() => {
            if (this.cnt > 0 && this.cnt <= TIME_COUNT) {
              this.cnt--
              this.RecBtnStr = '重新推荐(' + this.cnt + 'S)'
            } else {
              clearInterval(this.timer) // 清除定时器
              this.timer = null
              this.cnt = 0
              this.RecBtnStr = '重新推荐'
              this.recdisable = false
            }
          }, 1000)
        }
      } catch (error) {
        this.$message({
          showClose: true,
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,无法访问' : error.response.data.msg,
          type: 'error'
        })
        this.recdisable = false
      }
    },
    gotoRecShop () {
      var RecFoods = {}
      for (var i = 0; i < this.RecFoodList.length; i++) {
        RecFoods[this.RecFoodList[i].foodId] = this.RecFoodCnt[i]
      }
      this.$store.commit('SET_RECOMMEND', RecFoods)
      console.log(sessionStorage.getItem('recommend'))
      this.$router.push({path: '/browsefood/' + this.RecFoodList[0].foodShopId, query: {isRec: this.RecFoodList.length}})
    },
    settlement () {
      if (this.RecFoodList.length <= 0) {
        this.$message({
          type: 'error',
          message: '无推荐内容,无法生成订单'
        })
        return
      }
      this.$prompt('请输入收件地址', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消'
      }).then(({ value }) => {
        var foods = []
        var shopId = this.RecFoodList[0].foodShopId
        for (var i = 0; i < this.RecFoodList.length; i++) {
          var twins = []
          twins.push(this.RecFoodList[i].foodId)
          twins.push(this.RecFoodCnt[i])
          foods.push(twins)
        }
        this.postFoodOrder(foods, value, shopId)
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消购买'
        })
      })
    },
    async postFoodOrder (foods, addr, shopId) {
      try {
        const response = await BrowseFoodByShopID.Order({
          userId: this.user.userId,
          shopId: shopId,
          foodIdAndNum: foods,
          foodOrderLocation: addr
        }, {
          headers: {'Authorization': this.$store.state.token}
        })
        if (response.data.code !== 200) {
          this.$message({
            type: 'error',
            message: response.data.msg
          })
        }
        this.$message({
          type: 'success',
          message: response.data.msg
        })
        this.dialogTableVisible = false
        this.getOrderList()
        this.$forceUpdate()
      } catch (error) {
        this.$message({
          type: 'error',
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,不可达' : error.response.data.msg
        })
      }
    }
  }
}

</script>

<style scoped>
  .demo-table-expand {
    font-size: 0;
  }
  .demo-table-expand label {
    width: 100%;
    color: #99a9bf;
  }
  .demo-table-expand .el-form-item {
    margin-right: 0;
    margin-bottom: 0;
    width: 50%;
  }
  .el-header {
      background-color: #333;
  }
  .el-main {
      padding-top: 0;
  }
  .el-row {
  margin-bottom: 20px;
  display: flex;
  flex-wrap: wrap;
  }
  .el-col {
  border-radius: 0px;
  align-items: stretch;
  margin-bottom: 0px;
  margin-top: 30px;
  }
</style>
